#include <stdio.h>
#include <stdlib.h> 
#include <stdint.h>   /* Standard types */
#include <string.h>   /* String function definitions */
#include <unistd.h>   /* UNIX standard function definitions */
#include <fcntl.h>    /* File control definitions */
#include <errno.h>    /* Error number definitions */
#include <termios.h>  /* POSIX terminal control definitions */

#include <hiredis.h>

/*
practice run through for user space module sending pin values to redis
*/

int main(int argc, char **argv)
{
redisContext *context;
redisReply *reply;
struct timeval timeout = { 1, 500000 }; // 1.5 seconds

char buff[256];

int i, x, y;

char a, b, c, d, e, f;
long int p, q, r, s, t, u;
float g, h, j, k, l, m;

char* emc_bits[6] = {&a, &b, &c, &d, &e, &f};
long int* emc_s32s[6]= {&p, &q, &r, &s, &t, &u};
float* emc_floats[6]= {&g, &h, &j, &k, &l, &m};

    x = 1;
    y = 10;
    
    context = redisConnectWithTimeout("localhost", 6379, timeout);
    if (context->err) 
        {
        printf("Connection error: %s\n", context->errstr);
        exit(1);
        }

    /* PING server */
    reply = redisCommand(context,"PING");
    printf("PING: %s\n", reply->str);
    freeReplyObject(reply);

    bzero(buff,256);
        
    reply = redisCommand(context,"FLUSHDB");
    printf("FLUSHDB: %s\n", reply->str);
    freeReplyObject(reply);

    for (i = 0; i < 6; i ++)
        {
        *emc_bits[i] = 1;
        *emc_s32s[i] = (i * 5);
        *emc_floats[i] = (i * 7);
        }
            
    for (i = 0; i < 6; i ++)
        {
        printf("B%d = %d   D%d = %ld   F%d = %f\n", i, *emc_bits[i], i, *emc_s32s[i], i, *emc_floats[i]);
        }       

//////////////////////////////////////////////////////////////////// bits    
    for (i = 0; i < 6; i ++)
        {
        reply = redisCommand(context,"SET B%d %d", i, *emc_bits[i]);
        printf("SET: %s\n", reply->str);
        freeReplyObject(reply);
        }

    for (i = 0; i < 6; i ++)
        {
        reply = redisCommand(context,"GET B%d", i);
        printf("GET B%d: %s\n",i, reply->str);
        freeReplyObject(reply);
        }
///////////////////////////////////////////////////////////////////// s32s

    for (i = 0; i < 6; i ++)
        {
        reply = redisCommand(context,"SET D%d %ld", i, *emc_s32s[i]);
        printf("SET: %s\n", reply->str);
        freeReplyObject(reply);
        }

    for (i = 0; i < 6; i ++)
        {
        reply = redisCommand(context,"GET D%d", i);
        printf("GET D%d: %s\n",i, reply->str);
        freeReplyObject(reply);
        }

///////////////////////////////////////////////////////////////////// floats

    for (i = 0; i < 6; i ++)
        {
        reply = redisCommand(context,"SET F%d %f", i, *emc_floats[i]);
        printf("SET: %s\n", reply->str);
        freeReplyObject(reply);
        }

    for (i = 0; i < 6; i ++)
        {
        reply = redisCommand(context,"GET F%d", i);
        printf("GET F%d: %s\n",i, reply->str);
        freeReplyObject(reply);
        }    
 
    redisFree(context);
  
    return 0;
}
